"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonschema_1 = require("jsonschema");
const bind_di_1 = require("bind-di");
const appcomponents_1 = require("../lib/consts/appcomponents");
const schemavalidationerror_1 = __importDefault(require("../lib/errors/validation/schemavalidationerror"));
let JsonSchemaValidator = class JsonSchemaValidator {
    constructor() {
        this.validator = new jsonschema_1.Validator();
    }
    validate(body, schema, errorMessage = '') {
        const res = this.validator.validate(body, schema, { propertyName: 'Object' });
        if (!res.valid) {
            return new schemavalidationerror_1.default([errorMessage, res.toString()].join('\n'));
        }
        return undefined;
    }
};
JsonSchemaValidator = __decorate([
    bind_di_1.Component(appcomponents_1.JSON_VALIDATOR),
    __metadata("design:paramtypes", [])
], JsonSchemaValidator);
exports.default = JsonSchemaValidator;
//# sourceMappingURL=jsonschemavalidator.js.map