"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
const string_to_stream_1 = __importDefault(require("string-to-stream"));
const consts_1 = require("../../consts");
const debug = require('debug')('bind:rest:application');
const TAG = 'JSON_RESPONSE';
class JsonResponse {
    constructor(json, statusCode = 200, headers = {
        [consts_1.HEADER_NAMES.CONTENT_TYPE]: `${consts_1.CONTENT_TYPE.APPLICATION_JSON};charset=utf-8`,
    }, cookies = {}) {
        this.json = json;
        this.statusCode = statusCode;
        this.headers = headers;
        this.cookies = cookies;
        this[_a] = true;
        this.headers[consts_1.HEADER_NAMES.CONTENT_TYPE] = `${consts_1.CONTENT_TYPE.APPLICATION_JSON};charset=utf-8`;
    }
    get body() {
        debug('%s entered body(). Calling JSON.stringify', TAG);
        return JSON.stringify(this.json);
    }
    getReadStream() {
        return string_to_stream_1.default(this.body);
    }
}
exports.default = JsonResponse;
_a = consts_1.SYM_HAS_BODY;
//# sourceMappingURL=jsonresponse.js.map