"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getErrorFormatter = exports.formatError = void 0;
const appresponse_1 = require("../appresponse");
const debug = require('debug')('bind:rest:runtime:responsewriter');
const TAG = 'ERROR_FORMATTER';
const formatError = (error) => {
    if (!error) {
        return new appresponse_1.ErrorResponse(500);
    }
    if (error && typeof error.statusCode === 'number' && typeof error.body === 'string') {
        return error;
    }
    if (typeof error === 'string') {
        return new appresponse_1.ErrorResponse(400, error);
    }
    if (error instanceof Error) {
        return new appresponse_1.ErrorResponse(400, error.message);
    }
    return new appresponse_1.ErrorResponse(500);
};
exports.formatError = formatError;
const getErrorFormatter = (cntr) => {
    debug('%s entered getErrorFormatter. cntr=%s', TAG, cntr);
    return formatError;
};
exports.getErrorFormatter = getErrorFormatter;
//# sourceMappingURL=defaulterrorformatter.js.map