"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const bind_di_1 = require("bind-di");
const metaprops_1 = require("../../decorators/metaprops");
const debug = require('debug')('bind:rest:init');
const TAG = 'GET_ERROR_HANDLERS';
function getErrorHandlers(ctr) {
    const ret = ctr.components.filter((c) => {
        var _a;
        return ((_a = c.componentMetaData) === null || _a === void 0 ? void 0 : _a[metaprops_1.IS_ERROR_HANDLER]) !== undefined;
    });
    if (!bind_di_1.isDefined(ret)) {
        debug('%s No AppErrorHandler components found in container', TAG);
        return [];
    }
    const aErrHandlers = ret.map((component) => (ctx) => {
        const errorHandler = component.get([ctx]);
        return errorHandler.handleError(ctx);
    });
    return aErrHandlers;
}
exports.default = getErrorHandlers;
//# sourceMappingURL=geterrorhandlers.js.map