"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const bind_di_1 = require("bind-di");
const metaprops_1 = require("../metaprops");
const getparamtype_1 = __importDefault(require("./getparamtype"));
function applyNoParamDecorator(target, propertyKey, parameterIndex, required = false, methodParamType, paramFactory) {
    var _a;
    const paramTypes = Reflect.getMetadata(bind_di_1.PARAM_TYPES, target, propertyKey);
    const metaDetails = Reflect.getMetadata(metaprops_1.SYM_METHOD_PARAMS, target, propertyKey) || [];
    if (metaDetails[parameterIndex]) {
        if (metaDetails[parameterIndex].f && paramFactory) {
            throw new Error(`Method parameter ${parameterIndex} already defined 
      on method ${(_a = target.constructor) === null || _a === void 0 ? void 0 : _a.name}.${propertyKey}`);
        }
        if (required) {
            metaDetails[parameterIndex].isRequired = required;
        }
        else {
            metaDetails[parameterIndex].f = paramFactory;
            metaDetails[parameterIndex].paramDecoratorType = methodParamType;
            metaDetails[parameterIndex].paramType = getparamtype_1.default(paramTypes, parameterIndex);
            metaDetails[parameterIndex].paramName = bind_di_1.getMethodParamName(target, propertyKey, parameterIndex);
        }
    }
    else {
        metaDetails[parameterIndex] = {
            f: paramFactory,
            isRequired: required,
            paramDecoratorType: methodParamType,
            paramType: getparamtype_1.default(paramTypes, parameterIndex),
            paramName: bind_di_1.getMethodParamName(target, propertyKey, parameterIndex),
        };
    }
    Reflect.defineMetadata(metaprops_1.SYM_METHOD_PARAMS, metaDetails, target, propertyKey);
}
exports.default = applyNoParamDecorator;
//# sourceMappingURL=applysingledecorator.js.map