"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const bind_di_1 = require("bind-di");
const metaprops_1 = require("../metaprops");
const applicationerror_1 = __importDefault(require("../../errors/applicationerror"));
function RequestMatch(matcher) {
    return (target, propertyKey, descriptor) => {
        const metaData = Reflect.getMetadata(bind_di_1.COMPONENT_META_DATA, target) || {};
        if (metaData[metaprops_1.CONTROLLER_MATCHER]) {
            throw new applicationerror_1.default(`CONTROLLER_MATCHER is already defined 
      for controller "${target.constructor.name}.${propertyKey}" (${typeof (descriptor === null || descriptor === void 0 ? void 0 : descriptor.value)})`);
        }
        metaData[metaprops_1.CONTROLLER_MATCHER] = matcher;
        bind_di_1.defineMetadata(bind_di_1.COMPONENT_META_DATA, metaData, target, propertyKey)();
        return undefined;
    };
}
exports.default = RequestMatch;
//# sourceMappingURL=controllermatcher.js.map