"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const consts_1 = require("../../consts");
const getParamType = (paramTypes, index) => {
    let ret;
    if (paramTypes[index] && typeof paramTypes[index] === 'function') {
        switch (paramTypes[index].name) {
            case 'String':
                ret = consts_1.PARAM_TYPE_STRING;
                break;
            case 'Number':
                ret = consts_1.PARAM_TYPE_NUMBER;
                break;
            case 'Boolean':
                ret = consts_1.PARAM_TYPE_BOOLEAN;
                break;
            case 'Array':
                ret = consts_1.PARAM_TYPE_ARRAY;
                break;
            case 'Object':
                ret = consts_1.PARAM_TYPE_OBJECT;
                break;
            case 'Promise':
                ret = consts_1.PARAM_TYPE_PROMISE;
                break;
            default:
                ret = paramTypes[index];
        }
    }
    return ret;
};
exports.default = getParamType;
//# sourceMappingURL=getparamtype.js.map