"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const bind_di_1 = require("bind-di");
const metaprops_1 = require("../metaprops");
const decorateMethod = (decoratorFactory) => {
    return function controllerMethodDecorator(target, propertyKey, descriptor) {
        var _a;
        const targetStereotype = bind_di_1.getTargetStereotype(target);
        switch (targetStereotype) {
            case bind_di_1.TargetStereoType.CONSTRUCTOR:
                break;
            case bind_di_1.TargetStereoType.PROTOTYPE:
                if (!propertyKey ||
                    !descriptor ||
                    !descriptor.value ||
                    typeof descriptor.value !== 'function') {
                    throw new Error(`Custom controller decorator can be applied only to Class 
          or controller method.
          It was upplied to unsupported property of class "${(_a = target === null || target === void 0 ? void 0 : target.constructor) === null || _a === void 0 ? void 0 : _a.name}"`);
                }
                break;
            default:
                throw new Error(`Custom controller decorator can be applied only to Class 
        or controller method.`);
        }
        const aMiddlewares = Reflect.getMetadata(metaprops_1.SYM_CONTROLLER_MIDDLEWARES, target, propertyKey) || [];
        aMiddlewares.push(decoratorFactory);
        Reflect.defineMetadata(metaprops_1.SYM_CONTROLLER_MIDDLEWARES, aMiddlewares, target, propertyKey);
    };
};
function makeDecorator(f) {
    let ret;
    if (f) {
        ret = decorateMethod(f);
    }
    else {
        ret = (factory) => decorateMethod(factory);
    }
    return ret;
}
exports.default = makeDecorator;
//# sourceMappingURL=makemethoddecorator.js.map