"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const bind_di_1 = require("bind-di");
const metaprops_1 = require("./metaprops");
const debug = require('debug')('bind:rest:decorators');
const TAG = '@ErrorHandler';
function ErrorHandler(target) {
    debug('Defining %s for constructor %s', TAG, target.name);
    bind_di_1.Component(target);
    const metaData = Reflect.getMetadata(bind_di_1.COMPONENT_META_DATA, target) || {};
    metaData[metaprops_1.IS_ERROR_HANDLER] = true;
    bind_di_1.defineMetadata(bind_di_1.COMPONENT_META_DATA, metaData, target)();
    bind_di_1.defineMetadata(bind_di_1.DEFAULT_SCOPE, bind_di_1.ComponentScope.NEWINSTANCE, target)();
}
exports.default = ErrorHandler;
//# sourceMappingURL=errorhandler.js.map