"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metaprops_1 = require("./metaprops");
const debug = require('debug')('bind:rest:decorators');
const TAG = '@JsonSchema';
function JsonSchema(schema) {
    if (schema === null || typeof schema !== 'object') {
        throw new Error(`${TAG} schema must be an Object (a valid json schema). Check your classes annotated with ${TAG} and make sure the parameter is an object`);
    }
    return function JsonSchemaDecorator(target) {
        const x = require;
        const y = module;
        debug(x.name);
        debug(y.filename);
        debug('Defining %s for class %s', TAG, target.name);
        const type = Reflect.getMetadata(metaprops_1.SYM_JSON_SCHEMA, target);
        if (type) {
            throw new Error(`Cannot add ${TAG} decorator to Class '${target.name}' because it is already decorated with '${TAG}'`);
        }
        Reflect.defineMetadata(metaprops_1.SYM_JSON_SCHEMA, schema, target);
    };
}
exports.default = JsonSchema;
//# sourceMappingURL=jsonschema.js.map