"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const decompress_response_1 = __importDefault(require("decompress-response"));
const IncomingMessageResponse_1 = __importDefault(require("./IncomingMessageResponse"));
const headernames_1 = __importDefault(require("../consts/headernames"));
function decompressHttpResponse(response) {
    const im = response.getReadStream();
    const ORIGINAL_CONTENT_ENCODING = im.headers[headernames_1.default.CONTENT_ENCODING];
    const rs = decompress_response_1.default(im);
    if (['gzip', 'deflate', 'br'].includes(ORIGINAL_CONTENT_ENCODING)) {
        delete rs.headers[headernames_1.default.CONTENT_ENCODING];
    }
    return Promise.resolve(new IncomingMessageResponse_1.default(rs, response.requestID));
}
exports.default = decompressHttpResponse;
//# sourceMappingURL=decompressresponse.js.map