"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const appresponse_1 = require("../core/appresponse");
const applicationerror_1 = __importDefault(require("../errors/applicationerror"));
const headernames_1 = __importDefault(require("../consts/headernames"));
function jsonParseBody(resp) {
    return new Promise((resolve, reject) => {
        const { body } = resp;
        const contentType = resp.headers[headernames_1.default.CONTENT_TYPE] || '';
        try {
            const json = JSON.parse(body);
            resolve(new appresponse_1.JsonResponse(json, resp.statusCode, resp.headers));
        }
        catch (e) {
            reject(new applicationerror_1.default(`Failed to parse response as JSON. error="${e.message}" 
          response contentType="${contentType}" body=${body}`));
        }
    });
}
exports.default = jsonParseBody;
//# sourceMappingURL=jsonparsebody.js.map