"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toHTTPMethod = exports.httpMethodsMap = void 0;
const http_method_enum_1 = __importDefault(require("http-method-enum"));
const httpMethodsMap = {
    GET: http_method_enum_1.default.GET,
    POST: http_method_enum_1.default.POST,
    CONNECT: http_method_enum_1.default.CONNECT,
    DELETE: http_method_enum_1.default.DELETE,
    HEAD: http_method_enum_1.default.HEAD,
    OPTIONS: http_method_enum_1.default.OPTIONS,
    PATCH: http_method_enum_1.default.PATCH,
    PUT: http_method_enum_1.default.PUT,
    TRACE: http_method_enum_1.default.TRACE,
};
exports.httpMethodsMap = httpMethodsMap;
const toHTTPMethod = (method) => {
    const ret = httpMethodsMap[method] || 'UNSUPPORTED_METHOD';
    return ret;
};
exports.toHTTPMethod = toHTTPMethod;
//# sourceMappingURL=httpmethodsmap.js.map