"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jmespath_1 = require("jmespath");
const parsebody_1 = require("./parsebody");
const applicationerror_1 = __importDefault(require("../errors/applicationerror"));
function JMESPath(q) {
    try {
        jmespath_1.search({}, q);
    }
    catch (e) {
        throw new applicationerror_1.default(`Invalid JMESPath query. Error="${e.message}"`);
    }
    return (c) => (ctx) => {
        return parsebody_1.parseJsonBody(ctx).then((body) => {
            try {
                return jmespath_1.search(body, q);
            }
            catch (e) {
                throw new applicationerror_1.default(`JMESPath Failed to extract param from body. Error=${e.message}`);
            }
        });
    };
}
exports.default = JMESPath;
//# sourceMappingURL=jmespath.js.map