"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jsonpath_1 = require("jsonpath");
const parsebody_1 = require("./parsebody");
function JSONPath(q) {
    try {
        jsonpath_1.parse(q);
    }
    catch (e) {
        throw new Error(`Invalid JSONPath query. Error="${e.toString()}"`);
    }
    return (c) => (ctx) => {
        return parsebody_1.parseJsonBody(ctx).then((body) => {
            try {
                return jsonpath_1.value(body, q);
            }
            catch (e) {
                throw new Error(`JSONPath Failed to extract param from body. Error=${e.message}`);
            }
        });
    };
}
exports.default = JSONPath;
//# sourceMappingURL=jsonpath.js.map