"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors_1 = require("../errors");
const validateResponseCode = (isValid) => (resp) => {
    if (isValid(resp.statusCode)) {
        return Promise.resolve(resp);
    }
    return Promise.reject(new errors_1.ApplicationError(`Validate Response Code Error. statusCode=${resp.statusCode}`));
};
exports.default = validateResponseCode;
//# sourceMappingURL=validateresponsecode.js.map