"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lib_1 = require("../../../lib/");
const components_1 = require("../../../components");
const controller_1 = require("../../../lib/decorators/controller");
const middlewares_1 = require("../../../lib/decorators/middlewares");
const bind_di_1 = require("bind-di");
const decorators_1 = require("../../../lib/decorators");
const mw1_1 = require("./mw1");
const requestlogger_1 = __importDefault(require("./requestlogger"));
const utils_1 = require("../../../lib/utils");
const logger_1 = require("../decorators/logger");
const requireAdmin2 = (c) => (ctx) => {
    var _a;
    console.log('requireAdmin middleware called');
    if (((_a = ctx.req.headers) === null || _a === void 0 ? void 0 : _a.aoid) !== '1234') {
        throw new Error('You are not an admin');
    }
    return Promise.resolve(ctx);
};
const min3 = _ => _ => (val) => {
    if (!Array.isArray(val)
        || val.length < 3) {
        return Error('Must have at least 3 elements');
    }
};
const max4elements = (val) => {
    if (!Array.isArray(val)
        || val.length > 4) {
        return Error('Must have at maximum of 4 elements');
    }
};
const min3Elements = c => ctx => val => {
    if (!Array.isArray(val)
        || val.length < 3) {
        return Promise.resolve(Error('Must have at least 3 elements'));
    }
};
const min5Elements = c => ctx => val => {
    if (!Array.isArray(val)
        || val.length < 5) {
        return Error('Must have at least 5 elements');
    }
};
let Greeter = class Greeter {
    constructor() {
        this.abc = 'ABC';
    }
    set xlogger(obj) {
    }
    greet(mymethod, item, logger, context, name) {
        return __awaiter(this, void 0, void 0, function* () {
            this.logger.info('testing logger');
            return new lib_1.JsonResponse({ name, item, x: context.routeParams, e: this.abc });
        });
    }
    hello(user, m) {
        return __awaiter(this, void 0, void 0, function* () {
            return new lib_1.AppResponse(`HELLO ${user} with ${m}`);
        });
    }
    getBody(user, m) {
        return __awaiter(this, void 0, void 0, function* () {
            this.logger.info('Logger test');
            return new lib_1.AppResponse(`DEFAULT HELLO ${user} with ${m}`);
        });
    }
    helloDefault(user, m) {
        return __awaiter(this, void 0, void 0, function* () {
            this.logger.info('Logger test');
            return new lib_1.AppResponse(`DEFAULT HELLO ${user} with ${m}`);
        });
    }
    helloJson(user, m) {
        return __awaiter(this, void 0, void 0, function* () {
            this.logger.info('Logger test');
            return new lib_1.JsonResponse({
                name: user,
                method: m,
                age: 24
            });
        });
    }
};
__decorate([
    bind_di_1.Inject,
    __metadata("design:type", requestlogger_1.default)
], Greeter.prototype, "logger", void 0);
__decorate([
    bind_di_1.Inject,
    __metadata("design:type", requestlogger_1.default),
    __metadata("design:paramtypes", [requestlogger_1.default])
], Greeter.prototype, "xlogger", null);
__decorate([
    decorators_1.GET('/{item}/bar'),
    middlewares_1.Middlewares(mw1_1.MW1),
    __param(0, controller_1.RequestMethod),
    __param(1, controller_1.PathParam),
    __param(2, logger_1.Logger),
    __param(3, controller_1.Context),
    __param(4, controller_1.QueryParam), __param(4, controller_1.Validate(min3)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object, MyLogger,
        components_1.BindRestContext, Array]),
    __metadata("design:returntype", Promise)
], Greeter.prototype, "greet", null);
__decorate([
    decorators_1.GET,
    decorators_1.POST,
    controller_1.RequestMatch(ctx => { var _a; return ((_a = ctx.req.headers) === null || _a === void 0 ? void 0 : _a.aoid) === '123'; }),
    __param(0, controller_1.BodyParam(utils_1.JMESPath('first'))), __param(0, controller_1.Required),
    __param(1, controller_1.RequestMethod),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], Greeter.prototype, "hello", null);
__decorate([
    decorators_1.POST,
    __param(0, controller_1.Body),
    __param(1, controller_1.RequestMethod),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", Promise)
], Greeter.prototype, "getBody", null);
__decorate([
    decorators_1.GET,
    decorators_1.POST,
    __param(0, controller_1.BodyParam(utils_1.JMESPath('first'))), __param(0, controller_1.Required),
    __param(1, controller_1.RequestMethod),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], Greeter.prototype, "helloDefault", null);
__decorate([
    decorators_1.GET('/json'),
    __param(0, controller_1.QueryParam), __param(0, controller_1.Required),
    __param(1, controller_1.RequestMethod),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], Greeter.prototype, "helloJson", null);
Greeter = __decorate([
    controller_1.Controller,
    controller_1.Path('/baz'),
    middlewares_1.Middlewares(mw1_1.MW2),
    bind_di_1.NewInstance,
    __metadata("design:paramtypes", [])
], Greeter);
exports.default = Greeter;
class FakeController {
    doStuff() {
        return 'hello';
    }
}
const doSomething = (p) => {
    let x;
    console.log(x);
};
const parseArray = (a) => {
    console.log(a[0]);
};
const a1 = [1, 2];
doSomething(FakeController);
//# sourceMappingURL=greeter.js.map