const makePromise = (message) => Promise.resolve(message);
const makeRejectedPromise = (message) => Promise.reject(message);
const recover = e => makePromise(`Recovered from ${e.message}`);
const run = () => {
    return makePromise('one')
        .then(s => makePromise(`${s} two`))
        .then(s => { throw new Error('Bad deal'); })
        .then(s => makePromise(`${s} three`))
        .then(s => makePromise(`${s} three`), recover)
        .then(s => makePromise(`${s} four`));
};
run().then(s => {
    console.log(`RESULT: ${s}`);
}).catch(e => console.error(e.message));
//# sourceMappingURL=chain.js.map