/// <reference types="node" />
import http from 'http';
import { IfIocContainer } from 'bind-di';
import { ApplicationOptions } from '../interfaces/application';
import { IBindRestContext, IExitHandler, IServerResponse } from '../interfaces';
export declare const validateOptions: (options: ApplicationOptions) => void;
export declare class Application implements IExitHandler {
    private middlewares;
    private bindContainer;
    private configOptions;
    private defaultErrorFormatter;
    private defaultResponseWriter;
    constructor(options: ApplicationOptions);
    get settings(): ApplicationOptions;
    set settings(options: ApplicationOptions);
    get container(): IfIocContainer;
    setContainer(container: IfIocContainer): Promise<IfIocContainer>;
    onExit(exitCode: number): Promise<number>;
    private getErrorFormatter;
    private getResponseWriter;
    getAppResponse(context: IBindRestContext): Promise<IServerResponse>;
    handleRequest(req: http.IncomingMessage, res: http.ServerResponse): void;
    init(): Promise<boolean>;
    toString(): string;
}
