/// <reference types="node" />
import HttpResponseCode from 'http-status-enum';
import { IResponseHeaders } from '../../types/responseheaders';
import { IJsonResponse } from '../../interfaces/appresponse';
import { IResponseCookieValue } from '../../interfaces/responsecookie';
import { SYM_HAS_BODY } from '../../consts';
export default class JsonResponse<T> implements IJsonResponse<T> {
    json: T;
    statusCode: HttpResponseCode;
    headers: IResponseHeaders;
    cookies: NodeJS.Dict<IResponseCookieValue>;
    [SYM_HAS_BODY]: boolean;
    constructor(json: T, statusCode?: HttpResponseCode, headers?: IResponseHeaders, cookies?: NodeJS.Dict<IResponseCookieValue>);
    get body(): string;
    getReadStream(): NodeJS.ReadableStream;
}
