import { IBindRestContext, IControllerParamMeta } from '../interfaces';
import { AsyncContextParamValidator, IntoPromise } from '../types/paramvalidatorfunc';
export declare const printErrors: (errors: Array<Error>) => string;
export declare const isNullOrUndefined: (val: any) => boolean;
export declare const toNumber: (i: any) => Number | TypeError;
export declare const toArray: (i: any) => Array<any> | TypeError;
export declare const toBoolean: (s: any) => boolean | TypeError;
export declare const toString: (s: any) => string | TypeError;
export declare const paramTypeToString: (paramType: any) => string;
interface ParamsWithMeta {
    params: Array<any>;
    meta: Array<IControllerParamMeta>;
}
export declare function validateRequired(o: ParamsWithMeta): ParamsWithMeta;
export declare function setParamType(o: ParamsWithMeta): ParamsWithMeta;
declare function makeParamsValidator(meta: Array<IControllerParamMeta>, controllerName: string): (params: Array<any>) => Array<any>;
declare function makeValidateAsync(context: IBindRestContext, validators: Array<AsyncContextParamValidator>, controllerName: string): IntoPromise<Array<any>>;
export { makeParamsValidator, makeValidateAsync };
