import { ClassPrototype } from 'bind-di';
import HTTPMethod from 'http-method-enum';
import { ControllerFunc, IControllerMethodDecorator, IMethodDecorator } from '../../types';
import { IAppResponse } from '../../interfaces';
export declare const decorate: (pathOrTarget: string | ClassPrototype, propertyKey: string, method: HTTPMethod, descriptor?: TypedPropertyDescriptor<ControllerFunc>) => IMethodDecorator<ControllerFunc>;
export declare function GET(target: string): IControllerMethodDecorator;
export declare function GET(target: ClassPrototype, propertyKey: string, descriptor: TypedPropertyDescriptor<(...args: any[]) => Promise<IAppResponse>>): void;
export declare function POST(target: string): IMethodDecorator<ControllerFunc>;
export declare function POST(target: ClassPrototype, propertyKey: string, descriptor: TypedPropertyDescriptor<ControllerFunc>): void;
export declare function PUT(target: string): IMethodDecorator<ControllerFunc>;
export declare function PUT(target: ClassPrototype, propertyKey: string, descriptor: TypedPropertyDescriptor<ControllerFunc>): void;
export declare function DELETE(target: string): IMethodDecorator<ControllerFunc>;
export declare function DELETE(target: ClassPrototype, propertyKey: string, descriptor: TypedPropertyDescriptor<ControllerFunc>): void;
export declare function HEAD(target: string): IMethodDecorator<ControllerFunc>;
export declare function HEAD(target: ClassPrototype, propertyKey: string, descriptor: TypedPropertyDescriptor<ControllerFunc>): void;
export declare function OPTIONS(target: string): IMethodDecorator<ControllerFunc>;
export declare function OPTIONS(target: ClassPrototype, propertyKey: string, descriptor: TypedPropertyDescriptor<ControllerFunc>): void;
export declare function PATCH(target: string): IMethodDecorator<ControllerFunc>;
export declare function PATCH(target: ClassPrototype, propertyKey: string, descriptor: TypedPropertyDescriptor<ControllerFunc>): void;
export declare function TRACE(target: string): IMethodDecorator<ControllerFunc>;
export declare function TRACE(target: ClassPrototype, propertyKey: string, descriptor: TypedPropertyDescriptor<ControllerFunc>): void;
