/// <reference types="node" />
import HTTP_STATUS_CODES from 'http-status-enum';
import * as http from 'http';
import BindRestError from '../bindrest';
import { IHttpRequestOptions } from '../../interfaces';
export default class HttpResponseError extends BindRestError {
    readonly statusCode: HTTP_STATUS_CODES;
    readonly headers?: http.IncomingHttpHeaders;
    readonly options?: IHttpRequestOptions;
    constructor(message: string, statusCode: HTTP_STATUS_CODES, headers?: http.IncomingHttpHeaders, options?: IHttpRequestOptions, innerError?: Error);
}
