/// <reference types="node" />
import HttpStatusCode from 'http-status-enum';
import http from 'http';
import { IResponseCookieValue } from './responsecookie';
import ReadableStream = NodeJS.ReadableStream;
export interface IAppResponse {
    statusCode: HttpStatusCode;
    headers: http.IncomingHttpHeaders;
    body?: string;
    cookies?: NodeJS.Dict<IResponseCookieValue>;
    readonly getReadStream: () => ReadableStream;
}
export declare type IAppResponseWithBody = Required<Omit<IAppResponse, 'cookies'>> & {
    cookies?: NodeJS.Dict<IResponseCookieValue>;
};
export declare function isAppResponseWithBody(appResponse: Omit<IAppResponse, 'cookies'>): appResponse is IAppResponseWithBody;
export interface IJsonResponse<T extends {}> extends IAppResponseWithBody {
    json: T;
}
export interface IServerResponse {
    statusCode: HttpStatusCode;
    headers: NodeJS.Dict<string>;
    body?: string;
    cookies?: string[];
    readonly getReadStream: () => ReadableStream;
}
