import { ControllerFunc } from './controllers';
export declare type NonEmptyArray<T> = T[] & {
    0: T;
};
export declare type NotEmptyArray<T> = [T, ...T[]];
export declare type NonEmpty<T> = T extends Array<infer U> ? U[] & {
    '0': U;
} : never;
export declare type ControllerMethodNames<T> = {
    [K in keyof T]: T[K] extends ControllerFunc ? K : never;
}[keyof T];
export declare type FunctionPropertyNames<T> = {
    [K in keyof T]: T[K] extends Function ? K : never;
}[keyof T];
export declare type FunctionProperties<T> = Pick<T, FunctionPropertyNames<T>>;
