/// <reference types="node" />
import { ILogger } from '../../../';
import { Settings } from './settings';
export interface ILoggerSettings {
    LOG_LEVEL: string;
    LOG_LIMIT?: number;
}
export declare enum LOG_LEVEL {
    DEBUG = 0,
    INFO = 1,
    WARN = 2,
    ERROR = 3,
    FATAL = 4
}
export declare const truncateMessage: (message: string, limit: number) => string;
export declare const formatTimeStamp: (dt: Date) => string;
export declare const stringifyMessage: (message: any) => string;
export declare const stringifyHeaders: (headers: {
    [key: string]: string;
}) => string;
export declare class CehLogger implements ILogger {
    private readonly logLevel;
    private readonly logLimit;
    constructor(settings: Settings);
    protected getWriteStreams(_logLevel: LOG_LEVEL): Array<NodeJS.WritableStream>;
    protected format(logLevel: LOG_LEVEL, messages: any[]): string;
    protected doLog(logLevel: LOG_LEVEL, messages: any[]): void;
    fatal(...messages: any[]): void;
    error(...messages: any[]): void;
    warn(...messages: any[]): void;
    info(...messages: any[]): void;
    debug(...messages: any[]): void;
}
